<?php
include_once("dap-config.php");

$req = "cmd=_notify-validate";
foreach ($_REQUEST as $key => $value) {
    $value = urlencode(stripslashes($value));
    $req .= "&$key=$value";
    logToFile("dap-ipn: " . $key . "=" . $value, LOG_DEBUG_DAP);
}

logToFile($req);

$txn_num = 0;
$i = 1;
$post = array();
foreach ($_REQUEST as $key => $value) {
    $post[$key] = $value;
}

$post["txn_id"] = $post["transaction_id"];
$post["item_name"] = $post["product_name"];
$post["txn_type"] = $post["transaction_type"];
$post["buy_now"] = $post["sale"];
$post["first_name"] = $post["buyer_first_name"];
$post["last_name"] = $post["buyer_last_name"];
$post["email"] = $post["buyer_email"];
$post["amount"] = $post["transaction_amount"];
$post["payment_status"] = $post["transaction_type"];
$post["payment_processor"] = "Kartra";
$post["payer_email"] = $post["email"];

if (isset($post["secret_key"]) || ($post["secret_key"] != "")) {
    if (securityCheck($post) == -1) {
        return;
    }
}
$txn_num = 0;
$i = 1;
if (!isset($post["txn_id"]) || ($post["txn_id"] == "")) {
    $post["txn_id"] = rand() + 10000001;
}
if (!isset($post["mc_currency"]) || ($post["mc_currency"] == "")) {
    $post["mc_currency"] = "USD";
}

if (strcmp($post["txn_type"], "cancellation") === 0) {
    logToFile("dap-ipn: call processSubscriptionCancellation", LOG_DEBUG_DAP);
    processSubscriptionCancellation($post);
    return;
}

if (strcmp($post["txn_type"], "refund") === 0) {
    processRefund($post);
    return;
}


while (true) {
    logToFile("dap-ipn: success val" . $post["success"], LOG_DEBUG_DAP);
    logToFile("dap-ipn: payment_status" . $post["payment_status"], LOG_DEBUG_DAP);

    if (strcmp($post["payment_status"], "sale") == 0) {
        $post["payment_status"] = "Completed";
        if (strcmp($post["txn_type"], "cart") == 0) {
            $post["item_name"] = isset($_REQUEST["item_name" . $i]) ? $_REQUEST["item_name" . $i] : "";

            if ($post["item_name"] == "") {
                break;
            }

            $post["quantity"] = isset($_REQUEST["quantity" . $i]) ? $_REQUEST["quantity" . $i] : "";

            if (isset($post["amount" . $i])) {
                $post["mc_gross"] = $post["amount" . $i];
            }

            $post["txn_id"] = $post["txn_id"] . "-" . $i;
            processIPNResponse($req, $post, $i);
            $i++;
            $txn_num++;
        } else {
            $post["mc_gross"] = $post["amount"];
            processIPNResponse($req, $post, $i);
            break;
        }
    } else {
        $dap_error = "payment status = " . $post["status"] . " for the user = " . $post["email"];
        logToFile("dap-ipn: " . $dap_error, LOG_DEBUG_DAP);
        sendAdminEmail("dap-ipn:payment not accepted", $dap_error);
        return;
    }

    echo "SUCCESS!!!";

}

function processIPNResponse($req, $post, $i)
{
    //translate

    logToFile("processIPNResponse", LOG_DEBUG_DAP);
    $post["payer_email"] = $post["email"];

    if (securityCheck($post) == -1) {
        return;
    }

    $record_id = Dap_IPNProcessor::recordIPNIncoming($post);

    logToFile("dap-ipn-script.php: Recorded incoming . id:" . $record_id);
    //$original_request = $req;
    // post back to PayPal system to validate

    if ($record_id != -1) {
        //finally process the transaction
        Dap_Transactions::setRecordStatus($record_id, 1);
        Dap_Transactions::processTransaction($record_id);
    }

    $user = Dap_User::loadUserByEmail($post["payer_email"]);
    if (isset($user)) {
        logToFile("dap-ipn-script.php: user all set. SUCCESS" . $record_id);

    } else {
        logToFile("dap-ipn.php: user not found, contact site admin" . $record_id);
    }
}

function processRefund($post)
{
    logToFile("dap-ipn.php: processRefund(): ENTER processRefund()");
    $post["payer_email"] = $post["email"];
    $user = Dap_User::loadUserByEmail($post["payer_email"]);
    logToFile("dap-ipn.php: processRefund(): user found: email=" . $post["payer_email"]);
    if ($user) {
        $userId = $user->getId();
        $product = Dap_Product::loadProductByName($post["item_name"]);
        if ($product) {
            logToFile("dap-ipn.php: processRefund(): product found: product=" . $post["item_name"]);
            $productId = $product->getId();
            $userProduct = Dap_UsersProducts::load($userId, $productId);
            $transactionId = $userProduct->getTransaction_id();
            logToFile("dap-ipn.php: processRefund(): transactionId=" . $transactionId);
            $transactionIdRefund = Dap_Transactions::negate($transactionId);
            if ($transactionIdRefund) {
                logToFile("dap-ipn.php: processRefund(): refund complete, transactionIdRefund=" . $transactionIdRefund);
                //remove user's access to product
                Dap_UsersProducts::removeUsersProducts($userId, $productId);
                logToFile("dap-ipn.php: processRefund(): refund complete, remove user from product completed successfully");
            }
        }
    }
}

function processSubscriptionCancellation($post)
{
    $post["payer_email"] = $post["email"];
    logToFile("dap-ipn.php: processSubscriptionCancellation(): payer_email= " . $post["payer_email"]);
    if (isset($post["payer_email"])) {

        $user = Dap_User::loadUserByEmail($post["payer_email"]);
        logToFile("dap-ipn.php: processSubscriptionCancellation(): load user: " . $post["payer_email"]);
        if ($user) {
            $userId = $user->getId();
            logToFile("dap-ipn.php: processSubscriptionCancellation(): loadProductByName : " . $post["item_name"]);
            $product = Dap_Product::loadProductByName($post["item_name"]);
            if ($product) {
                $productId = $product->getId();
                $userProduct = Dap_UsersProducts::load($userId, $productId);
                logToFile("dap-ipn.php: processSubscriptionCancellation(): EXPIRE ACCESS END DATE TO TODAY, userId=" . $userId . ", productId=" . $productId);

                if ($userProduct != null) {
                    logToFile("EXPIRE ACCESS END DATE TO TODAY");
                    //we have existing users-products relationship, so we need to modify this.
                    $accessEndDate = date("Y-m-d", time());
                    $yesterday = date("Y-m-d", time() - 3600 * 24);
                    $access_start_date = $userProduct->getAccess_start_date();

                    $asd = strtotime($access_start_date);
                    $t = strtotime($accessEndDate);
                    $numdays = $t - $asd;
                    if ($numdays) {

                        // access end date to yesterday if access start date < today
                        $accessEndDate = $yesterday;
                        logToFile("dap-ipn.php: processSubscriptionCancellation(): numdays=" . $numdays . " AND access end to yesterday=" . $accessEndDate);
                    }

                    logToFile("dap-ipn.php: processSubscriptionCancellation(): access end=" . $accessEndDate);
                    $userProduct->setAccess_end_date($accessEndDate);
                    $userProduct->update();
                    logToFile("dap-ipn.php: processSubscriptionCancellation(): cancellation complete");
                } else {
                    logToFile("dap-ipn.php: processSubscriptionCancellation(): USERPROUDUCT NOT FOUND");
                }

            } //$product
        }//if($user) {
    } //if(isset($post["payer_email"]))

}


function securityCheck($post)
{
    logToFile("Running securityCheck");
    if ($post["secret_key"] != Dap_Config::get("SECRET_KEY")) {
        $dap_error = "security check failed: the cartId in payment notification does not match the cartId set in in dap setup -> config -> payment processing -> secret key  for the user = " . $post["email"];

        sendAdminEmail("DealGuardian: security check failed", $dap_error);
        echo "ERROR: " . $dap_error;
        return -1;
    }
    logToFile("dap-ipn.php: securityCheck successfully completed", LOG_DEBUG_DAP);
    return 0;
}

?>